close all;
clear all;
clc;

image_width  = 512;
image_height = 512;
imagesize = image_width*image_height;
image = zeros(1,imagesize);
fidh = fopen('image.txt','r');
for i=1:1:imagesize
    s=fscanf(fidh,'%s',1);
    image(i) = str2num(s);
end

kernel = [1 17 78 128 78 17 1];
image_size = 512;

for i=5:image_size-7   
	for j=5:image_size-7
        k=((i-1)*image_size + (j-1))+1;
        p0 = image(k-3)* kernel(1);
        p1 = image(k-2)* kernel(2); 	
		p2 = image(k-1)* kernel(3); 	
		p3 = image(k)* kernel(4);   	
		p4 = image(k+1)* kernel(5); 	
		p5 = image(k+2)* kernel(6); 	
		p6 = image(k+3)* kernel(7);
        p7 = 0;
        x(i,j) = p0+ p1 +p2 +p3 +p4 +p5 +p6 +p7;
    end
end

for i=1:4    
	for j=5:image_size-7
        x(i,j) = 0;
    end
end
for i=image_size-6:image_size   
    for j=5:image_size-7
        x(i,j) = 0;
    end
end
for j=1:4    
	for i=5:image_size-7
        x(i,j) = 0;
    end
end

for j=image_size-6:image_size
    for i=5:image_size-7
        x(i,j) = 0;
    end
end

sum_h = fi(x,0,32,0);
Res1   = bitsliceget(sum_h,20,9);
Res2  = double(Res1);

for i = 1: image_size
    for j= 1: image_size
        k=((i-1)*image_size + (j-1))+1;
        Res(k)= Res2(i,j);
    end
end
        
for i=5:image_size-7   
	for j=5:image_size-7
        k=((i-1)*image_size + (j-1))+1;
        p0 = Res(k-(3*image_size))* kernel(1);
        p1 = Res(k-(2*image_size))* kernel(2); 	
		p2 = Res(k-image_size)* kernel(3); 	
		p3 = Res(k)* kernel(4);   	
		p4 = Res(k+image_size)* kernel(5); 	
		p5 = Res(k+(2*image_size))* kernel(6); 	
		p6 = Res(k+(3*image_size))* kernel(7);
        p7 = 0;
        y(i,j) = p0+ p1 +p2 +p3 +p4 +p5 +p6 +p7;
    end
end

for i=1:4    
	for j=5:image_size-7
        y(i,j) = 0;
    end
end
for i=image_size-6:image_size   
    for j=5:image_size-7
        y(i,j) = 0;
    end
end
for j=1:4    
	for i=5:image_size-7
        y(i,j) = 0;
    end
end
for j=image_size-6:image_size   
    for i=5:image_size-7
        y(i,j) = 0;
    end
end

sum_v = fi(y,0,32,0);
Res3  = bitsliceget(sum_v,20,9);
Res4  = double(Res3);
figure(1), imagesc(Res4), axis image, colormap(gray),title('MATLAB Gaussian filtered');



image_width  = 512;
image_height = 512;
image_size = image_width*image_height;
id1 = zeros(1,image_size);
fidh = fopen('gaussian.txt','r');

for i=1:1:image_size
    s=fscanf(fidh,'%s',1);
    id1(i) = str2num(s);
end
id3 = reshape(id1,image_width,image_height);
id3 = id3';
figure(2), imagesc(id3), axis image, colormap(gray),title('FPGA Gaussian filtered');

diff=Res4(:,:)-id3(:,:);
figure(3), imagesc(diff), axis image, colormap(gray),title('Difference');