close all;
clear all;
clc;

image_width  = 512;
image_height = 512;
imagesize = image_width*image_height;
image = zeros(1,imagesize);
fidh = fopen('image.txt','r');
for i=1:1:imagesize
    s=fscanf(fidh,'%s',1);
    image(i) = str2num(s);
end


thres = 200;  %change threshold value here to get more or less edges.
image_size = 512;
for u = 2:510 
         for v = 2:510 
            k=((u-1)*image_size + (v-1))+1;
            p0 = image(k-(image_size+1)); 
			p1 = image(k-1);	 			
			p2 = image(k+(image_size-1)); 
			p3 = image(k-image_size);
			p5 = image(k+image_size); 	
			p6 = image(k-(image_size-1));
			p7 = image(k+1);	 			
			p8 = image(k+(image_size+1));
		
            gx=((p2-p0)+ (bitsll((p5-p3),1))+(p8-p6)); 
            gy=((p6-p0)+ (bitsll((p7-p1),1))+(p8-p2));
            sum(u,v) =  abs(gx) + abs(gy);
            
            if sum(u,v) > thres
                sum(u,v) = 255;
            else
                sum(u,v) = 0;
            end;
         end;
end;

for u = 1 
    for v = 2:510 
        sum(u,v) = 0;
    end
end

 for u = 511:512
    for v = 2:510 
        sum(u,v) = 0;  
    end
 end           

for v = 1 
    for u = 2:510 
        sum(u,v) = 0;
    end
end

 for v = 511:512
    for u = 2:510 
        sum(u,v) = 0;  
    end
 end           

 for u = 1:512
     for v = 1:512
        SobelImage(u,v) =  sum(u,v);
     end
 end
 
figure(1), imagesc(SobelImage), axis image, colormap(gray),title('MATLAB Sobel filtered');


image_width  = 512;
image_height = 512;
image_size = image_width*image_height;
id1 = zeros(1,image_size);
fidh = fopen('sobel.txt','r');

for i=1:1:image_size
    s=fscanf(fidh,'%s',1);
    id1(i) = str2num(s);
end
id3 = reshape(id1,image_width,image_height);
id3 = id3';
figure(2), imagesc(id3), axis image, colormap(gray),title('FPGA Sobel filtered');

diff=SobelImage(:,:)-id3(:,:);
figure(3), imagesc(diff), axis image, colormap(gray),title('Difference');